#!/usr/local/bin/perl

$database_file = "search.txt";

$input_error = "Cannot process input";
$file_error = "Cannot open file";
$database_error = "Database line corrupted";

$form_match = "match";
$form_show = "show";
$form_keys = "keys";


# Read CGI input
# split pairs in variables.
#
read (STDIN, $input, $ENV{'CONTENT_LENGTH'});
@pairs = split (/&/, $input);
if (scalar(@pairs) == 3) {
   foreach $pair (@pairs) {
      ($attribute, $value) =  split (/=/, $pair);
      $value =~ tr/+/ /;
      $value =~ s/%([\dA-Fa-f][\dA-Fa-f])/pack ("C", hex ($1))/eg;

      if ($attribute eq $form_match) {
         $match = $value;
      }
      if ($attribute eq $form_show) {
         $show = $value;
      }
      if ($attribute eq $form_keys) {
         @keys = split (/ /, $value);
      }
   }
}
else {
   print "$input_error\n";
   exit 0;
}


# Read the database
#
if (!open(D_FILE, $database_file)) {
   print "$file_error: $database_file\n";
   exit 0;
}
else {
   @data_list = <D_FILE>;
}
close(D_FILE);


# Process database
#
$count = 0;
foreach $data_entry (@data_list) {

   # Pavilion#URL#Description
   #
   if ($data_entry =~ /^([^#]*)#([^#]*)#([^#]*)/) {
      $pavilion = $1;
      $url = $2;
      $description = $3;
   }
   else {
      print ("$database_error: $data_entry\n");
   }

   # Search with a strong or loose match
   #
   if ($match eq "one") {
      # Loose match
      # case insensetive
      # one of the keys appears in the data.
      #
      $status = 0;
      foreach $key (@keys) {
         $case_key = "\U$key\E";
         $case_pavilion = "\U$pavilion\E";
         $case_description = "\U$description\E";
         if ( (index($case_pavilion, $case_key) > 0) || (index($case_description, $case_key) > 0) ) {
            $status = 1;
         }
      }
   }
   else {
      # Strong match
      # case insensetive
      # all of the keys appear in the data.
      #
      $status = 1;
      foreach $key (@keys) {
         $case_key = "\U$key\E";
         $case_pavilion = "\U$pavilion\E";
         $case_description = "\U$description\E";
         if ( (index($case_pavilion, $case_key) < 0) && (index($case_description, $case_key) < 0) ) {
            $status = 0;
         }
      }
   }
   
   if ($status == 1) {
      if ( ($count < $show) || ($show eq "all") ) {
         push (@entry, "<a target=\"_top\" href=\"$url\">$pavilion</a>");
         $count = $count + 1;
      }
   }
}


# HTML output
# 
print "Content-Type: text/html \n\n";
print "<HTML><HEAD><title>Search results</title></HEAD>\n";

print "<BODY BGCOLOR=\"#FFFFFF\" TEXT=\"#000000\" LINK=\"#FF0000\" VLINK=\"#FF0000\" ALINK=\"#FF0000\">\n";

print "<center>\n";

print "<table cellpadding=\"10\" border=\"0\" width=\"100%\">\n";

print "<tr><td align=\"left\" valign=\"center\">\n";
print "<font color=\"#FF0000\" size=\"+4\">S</font><font color=\"#FF0000\" size=\"+3\">earch results</font>\n";
print "</td></tr>\n";

print "<tr><td align=\"left\" valign=\"center\">\n";

print "<table cellpadding=\"10\">\n";
print "<tr><td align=\"left\" valign=\"center\">\n";
print "Your search results in $count hit(s):<p>\n";
print "</td></tr>\n";

print "<tr><td align=\"left\" valign=\"center\">\n";
print "<ul>\n";
foreach $entry (@entry) {
   print "<li>$entry\n";
}
print "</ul>\n";
print "</td></tr></table>\n";

print "</td></tr></table>\n";

print "</center>\n";

print "</BODY></HTML>\n";
